Last Comment Bug 700764 - Esc doesn't make iframe leave DOM fullscreen mode
: Esc doesn't make iframe leave DOM fullscreen mode
Status: VERIFIED FIXED
[qa!]
: verified-beta
Product: Core
Classification: Components
Component: DOM: Core & HTML (show other bugs)
: 11 Branch
: x86_64 Windows 7
: -- normal (vote)
: mozilla11
Assigned To: Chris Pearce (:cpearce)
:
:
Mentors:
http://www.thecssninja.com/demo/fulls...
Depends on:
Blocks: 545812
  Show dependency treegraph
 
Reported: 2011-11-08 12:24 PST by Daniel
Modified: 2012-02-07 04:16 PST (History)
5 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
unaffected
unaffected
+
verified
verified


Attachments
Patch (12.52 KB, patch)
2011-11-13 16:12 PST, Chris Pearce (:cpearce)
bugs: review+
asa: approval‑mozilla‑aurora+
Details | Diff | Splinter Review

Description Daniel 2011-11-08 12:24:17 PST
User Agent: Mozilla/5.0 (Windows NT 6.1; WOW64; rv:8.0) Gecko/20100101 Firefox/8.0
Build ID: 20111102223350

Steps to reproduce:

Viewing an iframe in DOM full-screen mode pressing the escape key doesn't make it leave fullscreen. 

str
1. Open http://www.thecssninja.com/demo/fullscreen/
2. Click the "Fullscreen iframe" button
3. Click anywhere inside the iframe
4. Now pressing escape has no effect
Comment 1 Chris Pearce (:cpearce) 2011-11-08 13:20:05 PST
So the issue here is that if you focus a non-fullscreen frame the key events won't go through the full-screen document's presshell's event handler. We should ensure that ESC *always* exits full-screen, and so check if the root document is full-screen rather than if the focused document is in PresShell::HandleEventInternal().
Comment 2 Chris Pearce (:cpearce) 2011-11-13 16:12:46 PST
Created attachment 574195 [details] [diff] [review]
Patch

Instead of checking if a keyevent's target document is full-screen, check if the root document is full-screen, and exit if ESC is pressed. This means if ESC is pressed when a non-full-screen iframe which is contained inside a full-screen document is focused, you'll still exit full-screen.
Comment 4 Ed Morley [:emorley] 2011-11-14 19:34:49 PST
https://hg.mozilla.org/mozilla-central/rev/53ef2ac3a1fc
Comment 5 Chris Pearce (:cpearce) 2011-11-14 19:49:31 PST
Comment on attachment 574195 [details] [diff] [review]
Patch

Requesting approval for Aurora because this bug prevents the a simple way to avoid the "Press ESC to leave full-screen" warning when in full-screen mode. Without this we're vulnerable to phishing.
Comment 6 Chris Pearce (:cpearce) 2011-11-15 16:50:55 PST
https://hg.mozilla.org/releases/mozilla-aurora/rev/e70f5c9f61b1
Comment 7 Paul Silaghi, QA [:pauly] 2012-01-03 04:48:14 PST
ESC key works fine now. This is verified fixed on Firefox 10 Beta2:
Mozilla/5.0 (Windows NT 6.1; WOW64; rv:10.0) Gecko/20100101 Firefox/10.0
Mozilla/5.0 (X11; Linux x86_64; rv:10.0) Gecko/20100101 Firefox/10.0
Mozilla/5.0 (Macintosh; Intel Mac OS X 10.6; rv:10.0) Gecko/20100101 Firefox/10.0
Comment 8 Paul Silaghi, QA [:pauly] 2012-02-07 04:16:45 PST
This is verified fixed on Firefox 11b1:
Mozilla/5.0 (Windows NT 6.1; WOW64; rv:11.0) Gecko/20100101 Firefox/11.0
Mozilla/5.0 (X11; Linux x86_64; rv:11.0) Gecko/20100101 Firefox/11.0
Mozilla/5.0 (Macintosh; Intel Mac OS X 10.6; rv:11.0) Gecko/20100101 Firefox/11.0

Note You need to log in before you can comment on or make changes to this bug.